#include "stdafx.h"
#include "WinNotify.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


const int MAX_WIDTH = 366;
const int MAX_HEIGHT = 288;


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_WM_ACTIVATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
  ID_INDICATOR_MSG,
};

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

  //Set the first pane of the status band non-strechable
  m_wndStatusBar.SetPaneInfo(0, ID_SEPARATOR, SBPS_NOBORDERS, 250);


	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZE;

  //Force the size of the main frame to just suround the formview
  cs.cx = MAX_WIDTH;
  cs.cy = MAX_HEIGHT;

	return CFrameWnd::PreCreateWindow(cs);
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG



void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMaxSize.x = MAX_WIDTH;
  lpMMI->ptMaxSize.y = MAX_HEIGHT;
	
	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}


void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CFrameWnd::OnActivate(nState, pWndOther, bMinimized);
	
  CString sText;
  int nNum = GetDoc()->GetNumberMessages();
  if (nState == WA_INACTIVE && bMinimized && nNum)
  {
    if (nNum == 1)
      sText.LoadString(AFX_IDS_APP_TITLE3);
    else
    {
      CString sNum;
      sNum.Format(_T("%d"), nNum);
      AfxFormatString1(sText, AFX_IDS_APP_TITLE2, sNum);
    }
  }
  else
    sText.LoadString(AFX_IDS_APP_TITLE);

  SetWindowText(sText);
}


CWinNotifyDoc* CMainFrame::GetDoc()
{
  POSITION posTemplate = AfxGetApp()->GetFirstDocTemplatePosition();
  VERIFY(posTemplate);
  CDocTemplate* pDocTemplate = AfxGetApp()->GetNextDocTemplate(posTemplate);
  VERIFY(pDocTemplate);
  POSITION posDoc = pDocTemplate->GetFirstDocPosition();
  VERIFY(posDoc);
  return (CWinNotifyDoc*) pDocTemplate->GetNextDoc(posDoc);
}

void CMainFrame::OnClose() 
{
	if (AfxMessageBox(IDS_EXIT_MSG, MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
  	CFrameWnd::OnClose();
}
