#ifndef __WINNOTIFYDOC_H__
#define __WINNOTIFYDOC_H__

#include "mailslot.h"


const int MAX_NAME_SIZE = MAX_COMPUTERNAME_LENGTH + 1;
const int MAX_MESSAGE_SIZE = 100;


//Structure which will be sent down the mailslot
struct CNotifyMessage
{
  SYSTEMTIME m_SentTime;
  TCHAR m_sSenderName[MAX_NAME_SIZE];
  TCHAR m_sSenderMachine[MAX_NAME_SIZE];
  TCHAR m_sTo[MAX_NAME_SIZE];
  TCHAR m_sMessage[MAX_MESSAGE_SIZE];
};



class CWinNotifyDoc : public CDocument
{
protected: // create from serialization only
	CWinNotifyDoc();
	DECLARE_DYNCREATE(CWinNotifyDoc)

	//{{AFX_VIRTUAL(CWinNotifyDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

  void CheckForNewMail();

public:
	virtual ~CWinNotifyDoc();
  CString GetCurrentMessage() const;
  CString GetCurrentSender() const;
  CString GetCurrentSenderMachine() const;
  CString GetCurrentTo() const;
  CString GetCurrentMessageTime() const;
  int     GetNumberMessages() const { return m_Messages.GetSize(); };
  int     GetCurrentMessageCount() const;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(CWinNotifyDoc)
	afx_msg void OnMessageClearAll();
	afx_msg void OnUpdateMessageClearAll(CCmdUI* pCmdUI);
	afx_msg void OnMessageDiscard();
	afx_msg void OnUpdateMessageDiscard(CCmdUI* pCmdUI);
	afx_msg void OnMessageNext();
	afx_msg void OnUpdateMessageNext(CCmdUI* pCmdUI);
	afx_msg void OnMessagePrevious();
	afx_msg void OnUpdateMessagePrevious(CCmdUI* pCmdUI);
	afx_msg void OnMessageSend();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

  CArray<CNotifyMessage, CNotifyMessage&> m_Messages;
  int m_nCurrentMessageIndex;
  CServerMailslot m_ServerMailslot;
};

class CSendDlg : public CDialog
{
public:
	CSendDlg(CWnd* pParent = NULL);   // standard constructor

	//{{AFX_DATA(CSendDlg)
	enum { IDD = IDD_SEND };
	CString	m_sMessage;
	CString	m_sTo;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CSendDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CSendDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__WINNOTIFYDOC_H__