#include "stdafx.h"
#include "resource.h"
#include "WinNotify.h"
#include "WinNotifyDoc.h"
#include "WinNotifyView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CWinNotifyView, CFormView)

CWinNotifyView::CWinNotifyView()
	: CFormView(CWinNotifyView::IDD)
{
	//{{AFX_DATA_INIT(CWinNotifyView)
	m_sMessage = _T("");
	m_sFrom = _T("");
	m_sTimeAndTo = _T("");
	//}}AFX_DATA_INIT
}

CWinNotifyView::~CWinNotifyView()
{
}

void CWinNotifyView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinNotifyView)
	DDX_Text(pDX, IDC_MESSAGE, m_sMessage);
	DDX_Text(pDX, IDC_FROM, m_sFrom);
	DDX_Text(pDX, IDC_TO_DATE, m_sTimeAndTo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWinNotifyView, CFormView)
	//{{AFX_MSG_MAP(CWinNotifyView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
  ON_UPDATE_COMMAND_UI(ID_INDICATOR_MSG, OnUpdateMessage)
END_MESSAGE_MAP()

#ifdef _DEBUG
void CWinNotifyView::AssertValid() const
{
	CFormView::AssertValid();
}

void CWinNotifyView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG


int CWinNotifyView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;

	//Create the timer to check for new mail
	m_nTimerID = SetTimer(1, 2000, NULL);
	
	return 0;
}

void CWinNotifyView::OnDestroy() 
{
	CFormView::OnDestroy();
	
  //Don't forget to destroy the timer
	KillTimer(m_nTimerID);
}

void CWinNotifyView::OnTimer(UINT /*nIDEvent*/) 
{
  //Check for new mail
  GetDoc()->CheckForNewMail();
}

void CWinNotifyView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/) 
{
  //Update the view based on the current message in the document
  m_sMessage = GetDoc()->GetCurrentMessage();
  if (GetDoc()->GetNumberMessages())
  {
    AfxFormatString2(m_sFrom, IDS_FROM, GetDoc()->GetCurrentSender(), GetDoc()->GetCurrentSenderMachine());
    AfxFormatString2(m_sTimeAndTo,   IDS_TO, GetDoc()->GetCurrentTo(), GetDoc()->GetCurrentMessageTime());

    AfxGetMainWnd()->SetIcon(GetApp()->m_hMessageIcon, FALSE);
    AfxGetMainWnd()->SetIcon(GetApp()->m_hMessageIcon, TRUE);
  }
  else
  {
    m_sFrom.LoadString(IDS_NO_MSGS);
    m_sTimeAndTo.Empty();

    AfxGetMainWnd()->SetIcon(GetApp()->m_hNoMessageIcon, FALSE);
    AfxGetMainWnd()->SetIcon(GetApp()->m_hNoMessageIcon, TRUE);
  }
  UpdateData(FALSE);
}

CWinNotifyDoc* CWinNotifyView::GetDoc() const
{
  return (CWinNotifyDoc*) GetDocument();
}

void CWinNotifyView::OnUpdateMessage(CCmdUI* pCmdUI)
{
  //Update the status bar message string
  CString sText;
  CString sNum1;
  CString sNum2;
  sNum1.Format(_T("%d"), GetDoc()->GetCurrentMessageCount());
  sNum2.Format(_T("%d"), GetDoc()->GetNumberMessages());
  AfxFormatString2(sText, IDS_INDICATOR_MSG, sNum1, sNum2);
  pCmdUI->SetText(sText);
}
